
//===============================================
//===============================================
MainProgram:
  gosub Instructions
  gosub SetUp
  gosub GenerateData
  while true
    ge3dto2da Points,Eye
    gosub plotdata
    Eye[1] = Eye[1]+pi()/10
  wend
end
//===============================================
//===============================================
SetUp:
  AbortMethod am_Exit
  XLimit = 800
  YLimit = 600
  data Eye;30,pi()/4,pi()/5,1220,400,300
  ox = 0 \ oy = 0
  XYText 100,100,"Please Wait.....","",30,fs_Bold
Return
//===============================================
GenerateData:
  Dim Points[18*36*2,5]
  n=0
  PHI = 0
  while PHI <= Pi()
    THETA = 0
    Points[n,3]=-1 \Points[n,4] = -1
    n=n+1
    while THETA <= PI(2)
      gosub CalcZ
      Points[n,0]=x \ Points[n,1] =y \ Points[n,2]=z
      n=n+1
      THETA = THETA+0.349060
    wend
    PHI = PHI+0.174530
  Wend
  PHI= 0
  while PHI <= Pi()
    THETA = 0
    Points[n,3]=-1 \Points[n,4] = -1
    n=n+1
    while THETA <= PI(2)
      gosub CalcZ_2
      Points[n,0]=x \ Points[n,1]=y \ Points[n,2]=z
      n=n+1
      THETA = THETA++0.349060
    wend
    PHI = PHI+0.174530
  Wend
Return
//===============================================
CalcZ:
   z = 5*cos(PHI)
   r = sqrt(25-z*z)
   x = r*cos(THETA) \ y = r*sin(THETA)
Return
//===============================================
CalcZ_2:
   r = 5*sin(THETA)
   x = r*cos(PHI)
   y = r*sin(PHI)
   z = 5*cos(THETA)
Return
//===============================================
plotdata:
  flip on
  setcolor black,white
  clearscr black
  fl = 0
  for i=0 to n-1
    sx = Points[i,3] \ sy = Points[i,4]
    if sx < 0 then fl=0 \continue
    if !within(sx,0,XLimit) or !within(sy,0,YLimit)
      fl = 0
      continue
    endif
    if fl = 0 
       gotoxy sx,sy
       fl = 1
    else
       lineto sx,sy,1,2
    endif
  next
  flip
  flip off
return
//===============================================
Instructions:
  data I_M;"Globe.Bas... Instructions..."
  data I_M;"This program demonstrates the Math and simple 3D-Engine capabilities of"
  data I_M;"RobotBASIC.",""
  data I_M;"This program and many more will be listed and analysed in a book currently"
  data I_M;"in development. The book will teach programming through the medium of computer"
  data I_M;"animation and game programming."
  n = MsgBox(I_M)
Return
//=======================================================
