MainProgram:
  GoSub Instructions
  while true  
    GoSub Initialize
    GoSub RBicaso
    repeat
       readmouse mx,my,mb
       getkey k
       if mb==2 || k == kc_Esc
           waitnokey
           fn = PromptBMP()
           if fn != "" then WriteBMP fn
           k = 0
       endif
    until k || mb==1
    waitnokey 1000
  wend
end
//===========================================================
Initialize:
    clearscr
    x = 0 \ y = 0 \ w = 800 \ h = 600
    PP_sp = 0
    linewidth 4
Return
//===========================================================
RBicaso:
    if w <= 50 || h <= 50 then return
    GoSub PushParams
    n=RGB(random(256),random(256),random(256))
    RectangleWH x+1,y+1,w-1,h-1,0,n
    n=random(3000)
    if within(n,1000,1999)
        midx = w/3+random(w/2)
        //midx = random(w)
        //line x+midx,y,x+midx,y+h,4,0
        line x+midx,y,x+midx,596,4,0
        w = midx \ GoSub RBicaso
        GoSub ReadParams
        x = x+midx \ w = w-midx \ GoSub RBicaso
        GoSub PopParams
    elseif within(n,2000,3000)
        midy = h/3+random(h/2)
        //midy = random(h)
        //line x,y+midy,x+w,y+midy,4,0
        line x,y+midy,796,y+midy,4,0
        h = midy \ GoSub RBicaso
        GoSub ReadParams
        y = y+midy \ h = h-midy \ GoSub RBicaso
        GoSub PopParams
    endif
Return
//===========================================================
PushParams:
    if !vType(PP_sp) then PP_sp = 0 
    if PP_sp==0 then dim PP_Stack[0] \ PP_dim = 0
    PP_sp = PP_sp+4
    if PP_sp > PP_dim
       data PP_Stack;x,y,w,h
       PP_dim = MaxDim(PP_Stack,1)
    else
       PP_Stack[PP_sp-4] = x
       PP_Stack[PP_sp-3] = y
       PP_Stack[PP_sp-2] = w
       PP_Stack[PP_sp-1] = h
    endif
Return
//===========================================================
PopParams: 
    PP_sp = PP_sp - 4
    x = PP_Stack[PP_sp]
    y = PP_Stack[PP_sp+1]
    w = PP_Stack[PP_sp+2]
    h = PP_Stack[PP_sp+3]
Return
//===========================================================
ReadParams:
    x = PP_Stack[PP_sp-4]
    y = PP_Stack[PP_sp-3]
    w = PP_Stack[PP_sp-2]
    h = PP_Stack[PP_sp-1]    
Return
//===========================================================
Instructions:
    data I_M;"RBicaso.bas"
    data I_M;"This program will present you with a set of randomly"
    data I_M;"generated art.",""
    data I_M;"Press left-mouse button or any keyboard key to proceed"
    data I_M;"from painting to another. If you keep the button pressed"
    data I_M;"the paintings will advance like a slide show every second.",""
    data I_M;"If you like a painting you can click the right mouse"
    data I_M;"button on it or press Esc key to save it to a file (bmp).",""
    data I_M;"The pictures are generated randomly and it might take"
    data I_M;"a few iterations before you get a worth while picture.",""
    data I_M;"                    Have Fun!"
    n=MsgBox(I_M)
    waitnokey
Return