//---y data
data Legend;"Original","Poly","Log","Exp"
data Legend;black,blue,red,cyan

data x; 160, 80, 40, 30, 20, 10, 1
data y;   1,  6, 12, 18, 24, 30, 37


n = maxdim(y,1) \ dim Points[2,n] \ dim r[n] \ dim p[n] \dim q[n]
for i=0 to n-1
  Points[0,i] = x[i] \  Points[1,i] = y[i]
next
m = 4  \ data Coefficients;m   //change m to 2 and 3 and 4 to see the effects
mPolyFit Points,Coefficients
mLogFit Points,a,b
mExpFit Points,c,d

data GPSpec;-1 \ mGraphPaper GPSpec
data GSpec;-1,-1,-1,-1,0,5 \ mPlotXY GSpec,x,y

for i=0 to n-1
  r[i] = 0 \ p[i] = 0 \ q[i] = 0
  for j=0 to m
     r[i] = r[i]+Coefficients[j]*x[i]^j
  next
  p[i] = a*NLog(x[i])+b
  q[i] = d*Exp(x[i]*c)
next
GSpec[4] = Legend[5] \ mPlotXY GSpec,x,r
GSpec[4] = Legend[6] \ mPlotXY GSpec,x,p
GSpec[4] = Legend[7] \ mPlotXY GSpec,x,q
xystring 140,100,Max(y)   \ xystring 140,490,Min(y) 
xystring 600,520,Max(x)   \ xystring 190,520,Min(x) 
xystring 370,520,"X-Axis" \ xystring 130,300,"Y-Axis"

y=400 \ x = 700
for i=0 to 3
   nn = y+15*i
   Line x-50,nn+10,x-5,nn+10,4,Legend[4+i]
   xyString x,nn,Legend[i]
next   

setcolor Legend[5]
xystring 450,1,"y = A0+A1*x+A2*x^2+A3*x^3+...+Am*x^m"
for i=0 to m
  xystring 550,20+15*i,"A",i,"=",Coefficients[i]
next

setcolor Legend[6]
xystring 1,1,"y = ",a,"*NLog(x)+",b
setcolor Legend[7]
xystring 1,20,"y = ",d,"*Exp(x*",c,")"

