//==================================================================
//==================================================================
//==Regression.Bas
//==   Demo of regression analysis
//==   position the mouse on the screen then press the 
//==   left button to plot the points
//==   you can plot 100 points, but if you need to stop before
//==   then use the right button to stop
//==================================================================
//==================================================================

//-----Variables
   Dim MyData[2,100]
   i=0
   fc = yellow
   bc = black

//==================================================================
MainProgram:
      GoSub DisplayInstructions
      GoSub GetPoints
      GoSub DisplayResult
end
//==================================================================
//==================================================================
//===Subroutines
//==================================================================
//==================================================================
DisplayInstructions:
  data IM;"Regression.Bas"
  data IM;"This program demonstrates the power of Arrays in RobotBASIC."
  data IM;"It allows you to plot various points on the screen using"
  data IM;"the left mouse button. When finished press the right-mouse"
  data IM;"button to see a LINE-FIT through the points and also the "
  data IM;"line Slope and Y-Intercept are displayed at the top of the "
  data IM;"screen.",""
  data IM;"This program uses array functions and commands to do its"
  data IM;"work"
  n=MsgBox(IM)
Return
//=============================================================
GetPoints:
   setcolor fc,bc
   clearscr
   while true
      delay 100
      ReadMouse X,Y,B
      if B = 1
         SetPixel X,Y,fc
         //xystring 0,0,i;X;Y
         MyData[0,i] = X
         MyData[1,i] = Y 
         i = i+1
         if i >= 100 then break
         B = 0
      else
         if B = 3 or B = 2 then break
      endif
   wend
return
//==================================================================
DisplayResult:
   setcolor white,bc
   if i <> 0 
      MRegression MyData,S,B
      xystring 0,0,"slope=",S;"Intercept=",B;"Corr Coef=",CorrCoef(MyData)
      gotoxy 0,B
      lineto 800,800*S+B
   endif
return
//==================================================================
