MainProgram:
  GoSub Initialization
  while true
    //nothing
  wend
end
//===================================================================================
bHandler:
   lb = LastButton()
   if lb == Buttons[0] then GoSub Convert
   if lb == Buttons[1] then GoSub Save
   if lb == Buttons[2] then n = MsgBox(IM)
   onButton bHandler
Return
//===================================================================================
cHandler:
   lcb = LastCheckBox()
   n = MakeBit(0,1,GetRBGroup("Format")-1) \ n = MakeBit(n,0,GetCheckBox("Display Text"))
   if Length(s) then SetMemoText "Text","" \ GoSub "WriteOut"+n
   onCheckBox cHandler
Return
//===================================================================================
rHandler:
   lrb = LastRBGroup()
   n = MakeBit(0,1,GetRBGroup("Format")-1) \ n = MakeBit(n,0,GetCheckBox("Display Text"))
   if Length(s) then SetMemoText "Text","" \ GoSub "WriteOut"+n
   onRBGroup rHandler
Return
//===================================================================================
Convert:
   fn = FilePrompt("*.*")
   if fn != ""
      SetMemoText "Text",""
      fh = FileOpen(fn,fo_Read) \ s = FileRead(fh,FileSize(fh)) \ x=FileClose(fh)
      n = MakeBit(0,1,GetRBGroup("Format")-1) \ n = MakeBit(n,0,GetCheckBox("Display Text"))
      GoSub "WriteOut"+n
   endif 
Return
//===================================================================================
Save:
   fn = FileSave("*.txt")
   if fn != ""
       if FileExt(s) == "" then fn=fn+".Txt"
       s = GetMemoText("Text")
       fh = FileCreate(fn) \ x = FileWrite(fh,s) \ x = FileClose(fh)
   endif
Return
//===================================================================================
WriteOut0: //Hex with no text
   ss = ""
   for i=1 to length(s)
     ss = ss+Hex(GetStrByte(s,i))+" "
   next   
   SetMemoText "Text",ss
Return
//===================================================================================
WriteOut1: //Hex with Text
   ln = Length(s)
   for i=1 to ln step 21
     ss = "" \ ss2 = ""
     for k = 0 to 20
       if k+i > ln then break
       n = GetStrByte(s,i+k)
       ss = ss+Hex(n)+" "
       if n < 32 
         ss2 = ss2+"."
       else
         ss2 = ss2+Char(n)
       endif  
     next
     if Length(ss) < 63 then ss=ss+sRepeat(" ",63-length(ss))
     AddMemoLine "Text",ss+"     "+ss2
   next
   SetMemoSelection "Text",1,0
Return
//===================================================================================
WriteOut2: //Decimal with no text
   ln = Length(s)
   for i=1 to ln step 22
     ss = "" 
     for k=0 to 21
       if k+i > ln then break
       ss = ss+Format(GetStrByte(s,i+k),"##0 ")
     next    
     AddMemoLine "Text",ss
   next   
   SetMemoSelection "Text",1,0
Return
//===================================================================================
WriteOut3: //Decimal with text
   ln = Length(s)
   for i=1 to ln step 17
     ss = "" \ ss2 = ""
     for k = 0 to 16
       if k+i > ln then break
       n = GetStrByte(s,i+k)
       ss = ss+Format(n,"##0 ")
       if n < 32 
         ss2 = ss2+"."
       else
         ss2 = ss2+Char(n)
       endif  
     next
     if Length(ss) < 68 then ss=ss+sRepeat(" ",68-length(ss))
     AddMemoLine "Text",ss+"     "+ss2
   next
   SetMemoSelection "Text",1,0
Return
//===================================================================================
Initialization:
  clearscr gray
  data Buttons;"Convert","Save","Instructions"
  data Formats;"Hex","Decimal"
  data IM;ProgName()
  data IM;"This program will read a binary file and output to the Memo box the bytes in"
  data IM;"the file converted to either Hex or Decimal formats. Also to the right of each"
  data IM;"line of byte values will be displayed the character that has that ASCII code"
  data IM;"if it is a displayable character or a . if not.",""
  data IM;"If you do not want the text displayed to the right and just display the bytes"
  data IM;"uncheck the check box.",""
  data IM;"To specify whether to convert the bytes to hex or decimal check the required"
  data IM;"radio button.",""
  data IM;"To specify the file to be converted press 'Convert' and specify the file"
  data IM;"to be converted.",""
  data IM;"If you wish to save the text in the Memo box to a file press the Button"
  data IM;"'Save' and specify the file","" 
  AddButton Buttons[0],10,20,100 \ AddButton Buttons[1],600,20,80 \ AddButton Buttons[2],700,20,80
  SetColor Black,Gray
  AddCheckBox "Display Text",370,20,"",1 \AddRBGroup "Format",120,10,220,40,2,mToString(Formats)
  SetRBGroup "Format",1 \   SetColor black,white
  Addmemo "Text",10,70,750,520 \ SetMemoFont "Text","Courier New",10 \ ReadOnlyMemo "Text"
  SetMemoScrollBars "Text",1
  s = ""
  onButton bHandler \ onCheckBox cHandler \ onRBGroup rHandler
Return
//===================================================================================
