Main:
  GoSub Initialization
  OnButton bHandler
  OnCheckBox cbHandler
  OnEdit eHandler
  OnListBox lbHandler
  while true
  wend
End
//===============================================================================
lbHandler:
  lb = LastListBox()
  SetEdit "Pattern",Templates[GetListBox("Templates")-1]
  onListBox lbHandler
Return
//===============================================================================
eHandler:
  le = LastEdit()
  if le == "Pattern"
     PatternChanged = true
  endif
  onEdit eHandler
Return
//===============================================================================
bHandler:
  lb = LastButton()
  if PatternChanged || ModeChanged
     Pattern = GetEdit("Pattern") 
     x = re_Setup(Pattern,Mode)
     ModeChanged = false
     PatternChanged = true
  endif   
  if lb == "&Match"
     SetCheckBox "MMatched",re_Match(GetMemoText("Text"))
  elseif lb == "&Get Number"
     SetEdit "GrpNum",re_GrpNumber(GetEdit("GrpName"))
  elseif lb == "&Undo"
     SetMemoText "Text",OText
  elseif lb == "&Replace"
     OText = GetMemoText("Text")
     SetMemoText "Text", re_Replace(GetMemoText("Text"),GetEdit("Replacement"),ToNumber(GetEdit("RFrom"),-1),ToNumber(GetEdit("HowMany"),-1))
  elseif lb == "&Instructions"
     x = MsgBox(IM)
  elseif lb == "Match Grou&p" && GetCheckBox("SMatched")
     x = re_Start(ToNumber(GetEdit("GrpNum"),-1))
     y = re_End(ToNumber(GetEdit("GrpNum"),-1))
     SetEdit "GStart",x \ setEdit "GEnd",y
     if x > 0 && y > 0
         SetMemoSelected "Text",x,y-x
     endif    
  elseif lb == "&Search"
     SetCheckBox "SMatched",re_Search(GetMemoText("Text"),ToNumber(GetEdit("SFrom"),-1))
     x = re_Start() \ y = re_End()
     SetEdit "Start",x \ setEdit "End",y
     SetEdit "GrpCount",re_NumOfGrps()
     if x > 0 && y > 0
         SetMemoSelected "Text",x,y-x
         SetEdit "SFrom",y
     else
         SetEdit "SFrom",-1    
     endif    
  endif
  OnButton bHandler
Return
//===============================================================================
cbHandler:
  lcb = LastCheckBox()
  x = ToNumber(lcb,-1)
  if x >= 0
    ModeChanged = true
    Mode = MakeBit(Mode,x,GetCheckBox(lcb))
  endif
  OnCheckBox cbHandler
Return
//===============================================================================
Initialization:
   GoSub Instructions
   GoSub InitArrays   
   PatternChanged = true
   ModeChanged = true
   Mode = RE_IGNORECASE | RE_MULTILINE
   OPattern = Templates[0]
   Pattern = OPattern
   clearscr gray
   addedit "Pattern",1,28,400
   addMemo "Text",1,90,400,400
   SetMemoScrollBars "Text",1
   addedit "Replacement",1,520,400
   addedit "SFrom",530,5,50 \ IntegerEdit "SFrom"
   addedit "Start",530,35,50 \ ReadOnlyEdit "Start"
   addedit "End",695,35,50 \ ReadOnlyEdit "End"
   AddButton "&Search",590,5
   AddButton "&Match",200,60
   addedit "RFrom",100,555,50 \ IntegerEdit "RFrom"
   addedit "HowMany",270,555,50 \ IntegerEdit "HowMany"
   AddButton "&Replace",340,555
   AddButton "&Undo",410,555
   addedit "GrpNum",530,75,50 \ IntegerEdit "GrpNum"
   addedit "GStart",530,105,50 \ ReadOnlyEdit "GStart"
   addedit "GEnd",695,105,50 \ ReadOnlyEdit "GEnd"
   AddButton "Match Grou&p",590,75
   addedit "GrpCount",555,150,50 \ ReadOnlyEdit "GrpCount"
   addedit "GrpName",543,185,140 \ IntegerEdit "GrpNum"
   AddButton "&Get Number",690,185,105
   AddButton "&Instructions",540,490,130
   AddListBox "Templates",600,260,190,mToString(TemplateNames)\SetListBox "Templates",1
   setcolor black,gray
   fnt = "Times New Roman"
   xyText 1,2,"Template Pattern:",fnt,14,fs_Bold
   xyText 1,65,"Text To Search:",fnt,14,fs_Bold
   xyText 1,495,"Replacement Text:",fnt,14,fs_Bold
   xytext 430,5,"Start From:",fnt,14,fs_Bold
   xytext 430,35,"Begins At:",fnt,14,fs_Bold
   xytext 583,35,"Ends Before:",fnt,14,fs_Bold
   AddCheckBox "SMatched",655,8," " \ EnableCheckBox "SMatched",false
   AddCheckBox "MMatched",260,65," "\ EnableCheckBox "MMatched",false
   xytext 2,555,"Start From:",fnt,14,fs_Bold
   xytext 170,555,"How Many:",fnt,14,fs_Bold
   xytext 430,75,"Group No.:",fnt,14,fs_Bold
   xytext 430,105,"Begins At:",fnt,14,fs_Bold
   xytext 583,105,"Ends Before:",fnt,14,fs_Bold
   xytext 430,150,"Groups Count:",fnt,14,fs_Bold
   xytext 430,185,"Group Name:",fnt,14,fs_Bold
   AddCheckBox "0",435,260,"Dot Match New Line"
   AddCheckBox "1",435,280,"MultiLine",1
   AddCheckBox "3",435,300,"Ignore Case",1
   AddCheckBox "4",435,320,"Right to Left"
   AddCheckBox "5",435,340,"Ignore White Space"
   xyText 430,235,"Mode:",fnt,15,fs_Bold
   xyText 600,235,"Some Templates:",fnt,15,fs_Bold
   setColor Blue,gray
   xyText 430,400,"Regular Expression",fnt,30,fs_Bold
   xyText 430,445,"  Experimentation Platform",fnt,20,fs_Bold
   SetEdit "SFrom",-1
   SetEdit "RFrom",-1
   SetEdit "HowMany",-1
   SetEdit "GrpNum",-1
   SetEdit "Pattern",OPattern
   SetEdit "GrpName","test"
   OText = mToString(IText)
   SetMemoText "Text",OText
   setcolor black,white
Return
//===============================================================================
Instructions:
  data IM;ProgName()
  data IM;"Regular Expressions are complex. But this program lets you play around and experiment"
  data IM;"with RegExps and makes learning them easier.",""
  data IM;"If you have a book and need to test out some of the given RegExps and see how they work"
  data IM;"this program lets you do so painlessly.",""
  data IM;"Enter the REgExp in the Template edit box and then either type in or paste some text into"
  data IM;"the Text memo box.",""
  data IM;"This done you can now try out to 'Match' the WHOLE text to the RegExp or you can 'Search'"
  data IM;"for a sub-text that matches the RegExp. When you match the check box next to the button"
  data IM;"will be checked if there is a match or will be unchecked if not.",""
  data IM;"When you search again the check box next to the button will be checked to indicate success"
  data IM;"or not. But, also, the character position of where the matched sub-text from within the whole"
  data IM;"begins will be put in the 'Begins At' field and the character position just after the end of"
  data IM;"the matched text will be put in the 'Ends Before' field.",""
  data IM;"Before you press the 'Search' button you should enter the character position from where you"
  data IM;"wish to start the searching. If this is not filled or is 0 or less then the searching will"
  data IM;"start from the beginning. Normally this is the left most character but if the check box "
  data IM;"'Right To Left' is checked in the Mode are then it will be the Rightmost character",""
  data IM;"The 'Start From' field will automatically be set to the value in the 'Ends Before' field"
  data IM;"after you press the 'Search' button. This makes it easy to keep searching the text from"
  data IM;"the start to the end by pressing the 'Search' button and not having to keep entering the"
  data IM;"'Start From' field. Also the 'Groups Count' filed will be updated with number of groups"
  data IM;"in the Template Pattern",""
  data IM;"You must have a successful match before you can press the 'Match Group' button and get a"
  data IM;"valid result. Also you must fill the 'Group No' filed for the group number yoi need to"
  data IM;"match. If this filed is not filled or is o or less then the matching will be done on the"
  data IM;"whole Pattern (i.e. group 0).",""
  data IM;"Matching a group after you have done a successful match will help you to see which sub-group"
  data IM;"from the pattern actually captured the matched text. The character position of the start and"
  data IM;"just after the end will be entered in the group 'Begins At' and Ends Before' fields",""
  data IM;"The 'Get Number' button will indicate the group number of the named group as is filled in"
  data IM;"the 'Group Name' field. The number returned will be set into the 'Group No.' field.",""
  data IM;"When you do successful matchcs the sub-text will also be highlighted in the Text area.",""
  data IM;"Press the 'Replace' button to cause the text that matches the pattern to be replaced with"
  data IM;"the text in the 'Replacement Text' filed. Fill the 'Start From' field with a number to start"
  data IM;"the searching and replacing from other than the beginning. If this number is 0 or less or"
  data IM;"is not entered then it will mean the beginning (again normally left but can be right).",""
  data IM;"Also enter the number of replacements in the 'How Many' field. If not entered or is 0 or less"
  data IM;"then all the matches will be replaced. You can press the 'Undo' button to undo the replacement"
  data IM;"and restore the text to what it was just before you did the operation." ,""
  data IM;"The 'Mode' area allows you set/unset different flags to affect how the searching and matching"
  data IM;"will be performed. See RobotBASIC's help file for information on these options and for more"
  data IM;"details about the whole Regular Expressions suite of functions.",""
  data IM;"The 'Some Templates' drop down list allows you to select from some interesting search patterns"
  data IM;"so you can play","",spaces(30)+"Have Fun!"
Return
//===============================================================================
InitArrays:
   data IText;"This program lets you experiment with Regular Expressions"
   data IText;"You can Enter text here or paste from the clipboard (Ctr+V)"
   data IText;"Also enter a RegExp pattern above.",""
   data IText;"Then experiment with Exact Matching, or Searching and also"
   data IText;"with Group matching and named groups etc."
   data IText;"You can also set the Mode of behavior of the RegExp engine."
   data IText;"You can also replace matched text with a replacement text from the box below",""
   data IText;"Some numbers 334 -3 34.56e+45   -45,456.33"
   data IText;"My address is Joe12@test.com or Joe@.com   IP 198.123.0.1",""
   data IText;"<B>this is text </B>",""
   data IText;"Today is 30/06/2001  30-06-2005"
   data IText;"Today is 06/30/2001 06-30-2003"
   data IText;"Today is 55/44/2001  35-22-1999",""
   data IText;"664"
   data IText;"23244",""
   data IText;"Credit Card No"
   data IText;"5234567834563456"

   data TemplateNames;"Default","EMail","Regular Expression","HTML Tags","IP Address","Numeric Range 0..999"
   data TemplateNames;"Floating Point Number","Date mm/dd/yyyy","Date dd/mm/yyyy","Valid Credit Card Number"
   data TemplateNames;"Whole line containing words","Three Words Near Each Other"
   data Templates;"(?<Test>[m].{1,5}[d])|(\b([Tt].{0,3}[tT])\b)"
   data Templates;"\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[a-zA-Z]{2,4}\b"
   data Templates;"reg(ular expressions?|ex(p|es)?)"
   data Templates;"<([A-Z][A-Z0-9]*)\b[^>]*>(.*?)</\1>"
   data Templates;"\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b"
   data Templates;"^([0-9]|[1-9][0-9]|[1-9][0-9][0-9])$"
   data Templates;"[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?"
   data Templates;"(0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])[- /.](19|20)\d\d"
   data Templates;"(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d"
   data Templates;"^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})$"
   data Templates;"^.*?\b(test|matched|text)\b.*$"
   data Templates;"\b(test|matched|text)(?:\W+\w+){1,6}?\W+(test|matched|text)\b"

Return
//===============================================================================
