//--Figure 4.4
  PEN_COLOR = DarkGray
MainProgram:
  GoSub Draw_Obstacles
  rlocate 400,200
  rInvisible PEN_COLOR
  gosub RemoteControl
end
//=============================================================
RemoteControl:
  rectangle 0,0,150,23,blue,blue
  s = " "+rGpsX()+","+rGpsY()+","+rCompass()+" UP"
  s = s+spaces(16-length(s))
  xystring 2,2,s  //--display the data
  p = up
  repeat
    readmouse x,y,b
    if b = 1 then Gosub GotoPoint  //left mouse button
    if b = 2 //--right mouse button
       p = !p
       rpen p,PEN_COLOR
       delay(300) //--edge detect the mouse button
    endif
    if b != 0  //--any buttons pressed
       s = " "+rGpsX()+","+rGpsY()+","+rCompass()
       if p = Up   then s = s+" UP"
       if p = Down then s = s+" Dn"
       s = s+spaces(16-length(s))
       xystring 2,2,s  //--display the data
    endif
  until false
Return
//=============================================================
Draw_Obstacles:
  rectangle 300,300,500,500,red,red
  circle 100,100,200,200,blue,blue
  circle 600,500,700,550,magenta,magenta
Return
//=============================================================
GotoPoint:
   dx = x-rGpsX()
   dy = y-rGpsY()
   if dx=0 AND dy = 0 then return
   Theta = PolarA(dx,dy)*180/pi(1)+90-rCompass()
   if Theta > 180 then Theta = Theta-360
   if Theta < -180 Then Theta = Theta+360
   rTurn Theta
   Distance = Round(PolarR(dx,dy))
   For I = 1 to Distance
     if rBumper() & 4 then break
     rForward 1
   next
return
//=============================================================
