//===========================================================
//===========================================================
MainProgram:
  GoSub SetUp
  GoSub Instructions
  while true
     GoSub MoveRobot
  wend
End
//===========================================================
//===========================================================
SetUp:
  AbortMethod am_Exit
  rlocate 400,300
  rinvisible red,cyan
Return
//===========================================================
MoveRobot:
   joystick 1,x,y,z,btn
   if btn==1 then rPen Down,Cyan
   if btn==2 then rPen Down,Red
   if btn==4 then rPen Up
   trn = round(x*10-5)  //transform (0 to 1) to (-5 to 5)
   if within(trn,-1,1) then trn=0 //--make the joystick have a dead center zone
   frwrd = round(y*10-5) //transform range (0 to 1) to (-5 to 5)
   if within(frwrd,-1,1) then frwrd = 0 //--make the joystick have a dead center zone
   while trn!=0 || frwrd!=0 //make simultaneous turn and forward one step at a time
      if trn !=0
         rturn 1*sign(trn)
         trn = trn-(1*sign(trn))
      endif
      if frwrd <0
         if !(rbumper()&4) then rforward 1  //forward as long as no obstacle ahead
         frwrd = frwrd+1
      elseif frwrd >0
         if !(rbumper()&1) then rforward -1 //backwaord as long as no obstacle behind
         frwrd = frwrd-1
      endif
   wend
Return
//===========================================================
Instructions:
  data I_M;"JoyStick_Robot.Bas.... Instructions..."
  data I_M;"This program demonstrates the use of the standard (not extended) JoyStick"
  data I_M;"command to control RobotBASIC's simulated robot.",""
  data I_M;"The joystick's y-axis is used to forward/back the robot. The x-axis is used"
  data I_M;"to turn the robot. The more you move the stick the faster the movement. So you"
  data I_M;"can make tighter and wider turns or circles.",""
  data I_M;"Also you can use button 1 to lower a Cyan (button 2 Red) pen. Button 3 is used"
  data I_M;"to raise the pen and stop drawing. The pen is initially up.",""
  n = MsgBox(I_M)
Return
//===========================================================
