ScrSetMetrics ,,,,0,1
MainProgram:
   GoSub Initialization
   while true
     setedit "Status",tcps_Status()
   wend
end
//-----------------------------------------------------------------------
Initialization:
    xytext 30,3,"The Server's","Ms San Serif",15,fs_Bold|fs_Underlined     
    xytext 2,30,"IP  :","",15,fs_Bold \ xytext 2,60,"Port:","",15,fs_Bold     
    xytext 412,90,"Status:","",15,fs_Bold
    AddEdit "LclIP",70,30,120,0,tcp_LocalIP()  \  AddEdit "LclPort",70,60,120,0,"50000"
    readonlyedit "LclIP" \ IntegerEdit "LclPort"
    AddEdit "Status",510,90,280 \ ReadOnlyedit "Status"
    ServeBtn = "&Start The Server"  \ AddButton ServeBtn,60,90,200 \StopBtn = "&Stop Serving"
    InstBtn   = "&Instructions"  \ AddButton InstBtn,260,20,100    
    ClrTxtBtn = "&Clear"  \ AddButton ClrTxtBtn,323,440,50    
    RingBtn   = "&Bell"  \ AddButton RingBtn,323,480,50    
    LogBtn   = "&Log"  \ AddButton LogBtn,323,520,50    
    ERectangle 10,130,790,173,5,Blue \ Line 380,130,380,600,5,blue
    xyText 100,138,"Local Data","",15,fs_Bold \ xyText 500,138,"Remote Data","",15,fs_Bold
    AddSlider "Here",10,210,250,-100,100
    AddSlider "There",410,210,250,-100,100 \ EnableSlider "There",0
    xystring 5,180,  "-100      Analog Input    100"
    xystring 405,180,"-100      Analog Input    100"
    AddEdit "Here",80,250,100,0,-100 \  AddEdit "There",480,250,100,0,-100
    ReadOnlyEdit "Here" \  ReadOnlyEdit "There"    
    AddListBox "List0",20,380,200 \ AddListBox "List1",420,380,200
    EnableListBox "List1",0
    for i=0 to 7
       if i < 2  
          data LEDs;255
          AddEdit "LEDs"+i,400*i+220,305,100,0,"0x"+Hex(LEDs[i])+"="+LEDs[i] 
          ReadOnlyEdit "LEDs"+i 
          xyText 400*i+20,360,"List Selection"   \ xyText 400*i+25,290,"Digital I/O"
          AddMemo "Text"+i,20+400*i,430,300,150 \ xyText 400*i+20,410,"Text Data"
          SetMemoScrollBars "Text"+i,1 
       endif   
       AddCheckbox "Sw0"+i,20+i*25,310," ",1 \AddCheckbox "Sw1"+i,420+i*25,310," ",1
       EnableCheckBox "Sw1"+i,0 \ AddListBoxItem "List0","Choice"+(i+1)
       AddListBoxItem "List1","Choice"+(i+1) 
    Next   
    Serving = false
    SetListBox "List0",1 \ SetListBox "List1",1 \ ReadOnlyMemo "Text1"
    onSlider slHandler \ onCheckBox cbHandler \ OnListBox lbHandler
    onButton bHandler \ onMemo mHandler 
Return
//-----------------------------------------------------------------------
SendData:
    if !Serving then return
    ts = GetMemoText("Text0")
    s = "" \ BuffPrintB s,Length(ts),getSliderpos("Here"),ToByte(LEDs[0])
    BuffPrintB s,GetListBox("List0"),ts
    n=tcps_Send(s)
Return
//-----------------------------------------------------------------------
SendBeep:
    if !Serving then return
    s = "" \ BuffPrintB s,-1,getSliderpos("Here"),ToByte(LEDs[0])
    BuffPrintB s,GetListBox("List0")
    n=tcps_Send(s)
Return
//-----------------------------------------------------------------------
slHandler:
   lsl = LastSlider() \ x = getSliderpos(lsl)\ setedit lsl,x
   if lsl=="Here" then GoSub SendData
   onSlider slHandler
Return
//-----------------------------------------------------------------------
cbHandler:
   lcb = LastCheckBox() \ n=tonumber(right(lcb,2)) \ nn=n/10 \ n=n#10
   LEDs[nn] = MakeBit(LEDs[nn],7-n,getCheckBox(lcb))
   SetEdit "LEDs"+nn,"0x"+Hex(LEDs[nn])+"="+LEDs[nn]
   if nn==0 then GoSub SendData
   onCheckBox cbHandler
Return
//-----------------------------------------------------------------------
lbHandler:
   llb = LastListBox()
   if llb == "List0" then GoSub SendData
   onListBox lbHandler
Return
//-----------------------------------------------------------------------
bHandler:
   lb=LastButton()
   if lb==ServeBtn
       renamebutton lb,StopBtn \ Serving = true
       n = Limit(ToNumber(GetEdit("LclPort"),50000),1,0xFFFF) \ SetEdit "LclPort",n
       n=tcps_Serve(n) \ enableedit "LclPort",0
       n=tcps_Read()  //clear the buffer
       onTCPS tcpsHandler 
   elseif lb == StopBtn
       n = tcps_Close() \ onTCPS  //stop event handling
       enableedit "LclPort"
       renamebutton lb,ServeBtn \Serving = false     
   elseif lb == ClrTxtBtn 
       SetMemoText "Text0",""
       FocusMemo "Text0"
   elseif lb == RingBtn 
       Beep \ GoSub SendBeep
   elseif lb == LogBtn
       GoSub LogMemos
   elseif lb == InstBtn
       GoSub Instructions    
   endif    
   onButton bHandler
Return
//-----------------------------------------------------------------------
mHandler:
   lsm = LastMemo()
   if lsm=="Text0" then GoSub SendData
   onMemo mHandler
Return
//-----------------------------------------------------------------------
tcpsHandler:
   if tcps_buffcount() >= 13
      ss = tcps_read()
      L = BuffReadI(ss,0)
      If L < 0 then Beep
      SetSliderPos "There",BuffReadI(ss,4)
      LEDs[1] = BuffReadB(ss,8)
      for i=0 to 7
          SetCheckBox "Sw1"+i,LEDs[1] & 2^(7-i)
      next
      SetListBox "List1",BuffReadI(ss,9)
      If L >=0
         ss = BuffRead(ss,13,L)
         SetMemoText "Text1",ss 
         SetMemoSelection "Text1",MemoLinesCount("Text1")+1,-1,0
         FocusMemo "Text0"
      endif
   endif
   onTcps tcpsHandler
Return
//-----------------------------------------------------------------------
LogMemos:
    fln = "ServerLog.Txt"
    if FileExists(fln)
        flh = FileOpen(fln,fo_Write)
        lmx = FileSeek(flh,2,0)
    else
        flh = FileCreate(fln)
    endif
    lms = sRepeat("=",100)+crlf()+"----Sent Text On:"+DateTime(Now(),"dddd mmmm dd,yyyy hh:mm:ss")
    lms = lms+crlf()+sRepeat("-",100)+crlf()
    lms = lms+GetMemoText("Text0")+crlf()
    lms = lms+sRepeat("-",100)+crlf()+"----Received Text On:"+DateTime(Now(),"dddd mmmm dd,yyyy hh:mm:ss")
    lms = lms+crlf()+sRepeat("-",100)+crlf()
    lms = lms+GetMemoText("Text1")+crlf()
    flx = FileWrite(flh,lms) \ flx = FileClose(flh)
Return
//-----------------------------------------------------------------------
Instructions:
    if vType(InstFt)then InstFt = MsgBox(IM) \ return
    data IM;ProgName()
    data IM;"This is a demo for the TCP support in RobotBASIC V4.0.0",""
    data IM;"This program is the Server end of the connection.",""
    data IM;"To use this Server version. You need to have the Client version running either"
    data IM;"on another machine or even on this machine.",""
    data IM;"Decide on what port number you want the server to LISTEN on and type it in the"
    data IM;"Local Port field. Then press the 'Start The Server' button to activate the"
    data IM;"Server and have it in the LISTENING mode.",""
    data IM;"On the client end you must enter the IP and Port of the Server and then Connect"
    data IM;"to the server.",""
    data IM;"Once the server has accepted a client request it will show a status of"
    data IM;"'Accepted:Address... where address is the IP address of the accepted client."
    data IM;"Once the client is connected to the server you now have a two way asynchronous"
    data IM;"comm line between the server and client and they both can send and receive data"
    data IM;"from/to each other",""
    data IM;"Any changes you make to the controls on the left side of the screen would be"
    data IM;"reflected on the client's right side and any changes done to the client's"
    data IM;"controls on the left will be reflected on the server's right side.",""
    data IM;"The Clear Button next to the memo box on the left will clear the memo box."
    data IM;"The Bell button will cause an audible Beep on the client side as well as on the"
    data IM;"server side. This is a good way of attracting atention of a person on the other"
    data IM;" side. The Log button causes the contents of the Memo boxes (left and right) to be"
    data IM;"APPENDED to a log file called ClientLog.Txt with a date and time tag.",""
    data IM;"This demonstrates sending/receiving binary or text data using the TCP protocol.",""
    data IM;"To send data across the LAN you won't have to do any Fire Wall settings and "
    data IM;"the IPs are Local LAN IPs as set by your Router.",""
    data IM;"To send data over the internet you will need to setup the routers on both sides"
    data IM;"of the link so that the routers' firewalls would not block the ports required."
    data IM;"Additionally, you need to tell the router to direct the data to the target"
    data IM;"machines.....HOWEVER....when you put the IP addresses you need to type in the IP"
    data IM;"address of the server's router as it appears on the internet....your router's setup"
    data IM;"screen will show this or you can use a website (like http://www.whatismyip.com/)"
    data IM;"that tells you your internet IP.",""
    data IM;"This is not trivial you should read this PDF:"
    data IM;"   http://www.robotbasic.org/resources/RobotBASIC_Networking.PDF",""
    data IM;spaces(40)+"Have Fun!"
    InstFt = MsgBox(IM)
Return