//----------RB2Prop_IO_Binary.Bas------------------------
//  Use the SPIN program RB2Prop_IO_Binary.Spin.

CommPort = 4  //change this to reflect your setup
setcommport CommPort,br115200,8,pNone,sbOne,fcNone
ClearSerBuffer
xystring 10,5,"Automatically Resetting The Propeller Program now...."
setserdtr \ setserdtr 0 \ setserdtr
while true
   repeat  //wait for the "Rdy"
     checkserbuffer n
   until n == 3
   SerIn s \ if s == "Rdy" then break
wend //repeat until the "Rdy" string is received
//add edit boxes and buttons and instructions
addedit "v1",50,50,100,0,70 
addedit "v2",170,50,100,0,48
addedit "re",310,50,100,0,"0"  \ readonlyedit "re"
addbutton "Calc",80,100,100
xystring 10,5,"OK the Propeller is ready...."+spaces(10)
xystring 10,25,"Enter numbers in the edit boxes then press the 'Calc' button"
xytext 155,45,"+","",15
xytext 290,45,"=","",15
while true  //repeat for ever
  repeat  //wait for the calc button to be pressed
  until LastButton() =="Calc"
  //get the numbers from the edit boxes
  v1 = tonumber(getedit("v1"),0) \ v2 = tonumber(getedit("v2"),0)
  //send the two numbers as binary buffers that contain the Little-endian
  //format of the numbers....8 bytes total  
  serout Buffwrite("",0,v1),buffwrite("",0,v2)
  repeat //wait until there 4 bytes (one 32 bit binary number)
    checkserbuffer n
  until n>=4
  serin s   //read the buffer
  //assign the number (text) to the result edit box
  setedit "re",BuffReadI(s,0)  //convert the buffer to Integer value)
wend
