MainProgram:

    //---------------------------
    // Discover the USB devices
    //---------------------------

    // Preset big number
    usbm_finddevices()
    print "Number of USB devices: " + usbm_numberofdevices()
    print

    usbm_Wire2Control( 0, 0 )

    For loopyrow = 0 To 15
        For loopycol = 0 To 15
            // Send start control signal (drop data line low )
            usbm_Wire2Control( 0, 1 )

            // Send slave address byte
            usbm_Wire2Data( 0, char(0x00)+char(0x01)+char(0xA0) )

            // Send EEPROM address byte
            usbm_Wire2Data( 0, char(0x00)+char(0x01)+char(loopyrow * 16 + loopycol) )

            // Send stop control signal (clock high, then data high)
            usbm_Wire2Control( 0, 2 )


            // Send start control signal (drop data line low )
            usbm_Wire2Control( 0, 1 )

            // Send slave address byte
            usbm_Wire2Data( 0, char(0x00)+char(0x01)+char(0xA1) )

            // Send dummy data byte
            EEPROMbyte = usbm_Wire2Data( 0, char(0x00)+char(0x01)+char(0xFF) )

            //Send stop control signal (clock high, then data high)
            usbm_Wire2Control( 0, 2 )

            print Hex(GetStrByte( EEPROMbyte, 2)), " ",
        Next loopycol
        print
    Next loopyrow
End


