01 MainProgram:
02  DeviceNum = 0
03  if usbm_DllSpecs() != ""
04    if usbm_FindDevices() 
05      //---there is a device and we will use device 0
06      n = usbm_DirectionA(DeviceNum,0x0F,0x0F)  //A0 to A3 output
07      n = usbm_DirectionB(DeviceNum,0xFF,0xFF) //Port B output
08      GoSub Init_LCD
09      S = "Hello there"
10      while true
11         GoSub Write_LCD
12         Input "Enter a text:",S
13      wend   
14    else
15      print "There are no Devices"
16    endif   
17  else
18    print "The USBmicro DLL is not installed"   
19  endif
20 end
//================================================
Init_LCD:
  if !usbm_DeviceValid(DeviceNum) then return
  n = usbm_InitLCD(DeviceNum, 0x12, 0x13)   //---RW=A1,RS=A2,E=A3,Data=Port B     
  n = usbm_SetBit(DeviceNum,0)  \ delay 20  //---RES connected to A0
  n = usbm_ResetBit(DeviceNum,0)\ delay 100 //High-Low-High to reset with 100 ms pulse
  n = usbm_SetBit(DeviceNum, 0) \ delay 100 //give the LCD time to settle
  n = usbm_LCDCmd(DeviceNum, 0x1C)  //---command sequence to setup the LCD
  n = usbm_LCDCmd(DeviceNum, 0x14)  //---this is obtainable from the device
  n = usbm_LCDCmd(DeviceNum, 0x28)  //---specs sheet
  n = usbm_LCDCmd(DeviceNum, 0x4F)  //
  n = usbm_LCDCmd(DeviceNum, 0xE0)  //
  n = usbm_LCDCmd(DeviceNum, 0x1)   //--clear the LCD display
Return
//=========================================================
Write_LCD: //S is the string to write
  if !usbm_DeviceValid(DeviceNum) then return
  n = usbm_LCDCmd(DeviceNum, 0x1)  //code 0x1 clears the LCD
  if Length(S) == 0 then Return
  for i = 1 To Length(S)    
    n=usbm_LCDData(DeviceNum,GetStrByte(S,i)) //send ascii code of each character
  next
Return
//=========================================================
