MainProgram:
   GoSub Initialization
   while true
     SetEdit "Status",udp_STatus("u1")
   wend
end
//================================================
Initialization:
  lclPort = 47000  \ Tc = -40
  x = udp_start("u1",lclPort)
  xyText 50,50,"Local IP    = "+TCP_LocalIP(),"Times new roman",14,fs_Bold
  xyText 50,70,"Local Port = "+lclPort,"Times new roman",14,fs_Bold
  xyText 500,50,"Remote IP    = ","Times new roman",14,fs_Bold
  xyText 500,80,"Remote Port = ","Times new roman",14,fs_Bold
  xyText 550,150,"Socket Status","Times new roman",14,fs_Bold
  AddEdit "rmtIP",630,50,100,0,tcp_LocalIP()
  AddEdit "rmtPort",630,80,60,0,46000 \ IntegerEdit "rmtPort"
  AddEdit "Status",500,180,250
  AddCheckBox "Allow Sending",530,110
  xyText 200,5,"Controller Program","Times new roman",20,fs_Bold|fs_Underlined
  xyText 10,130,"Temperature    =","",15,fs_Bold
  xyText 10,160,"Stepping State =","",15,fs_Bold
  AddSlider "Rate",50,300,300,-255,255 \ SetSliderPos "Rate",0
  AddEdit "Rate",175,340,50,0,0 \ ReadOnlyEdit "Rate"
  xyText 30,280,"-255","",10,fs_Bold
  xyText 330,280,"+255","",10,fs_Bold
  xyText 196,280,"0","",10,fs_Bold
  xyText 120,250,"Motor Speed","",20,fs_Bold
  FocusSlider "Rate"
  onudp udpHandler \ onSlider sHandler
Return
//================================================
sHandler:
   ls = LastSlider()
   n = GetSliderPos(ls)
   SetEdit ls,n
   if GetCheckBox("Allow Sending")
      n = udp_Send("u1",BuffWrite("",0,n),GetEdit("rmtIP"),ToNumber(GetEdit("rmtPort"),0))
   endif
   onSlider sHandler
Return
//================================================
udpHandler:
   if udp_BuffCount("u1") >= 12
      SS = udp_Read("u1")
      Tc = BuffReadF(SS,0) \ Tf = 1.8*Tc+32
      Motor = BuffReadI(SS,8)
      xyText 200,130,Format(Tc,"##0.00C = ")+Format(Tf,"0.00F")+spaces(10),"",15,fs_Bold
      xytext 205,155,bin(Motor&0x0F,4),"",20,fs_Bold
   endif
   onUDP udpHandler
Return
//================================================
