data Eye;120,pi(.25),pi(.25),1550,400,300 //rho,theta,phi,d,Cx,Cy
x = 15
data points;0,0,0,0,0, 0,0,x,0,0, 0,x,x,0,0, 0,x,0,0,0
data points;x,x,0,0,0, x,x,x,0,0, x,0,x,0,0, x,0,0,0,0
dim Points[8,5] \ mcopy points,Points  //make appropriate array of vertices
data surfaces;red,0,0,1,2,3,  blue,0,5,2,1,6
data surfaces;green,0,3,2,5,4,  yellow,0,4,5,6,7  //surfaces
data surfaces;gray,0,3,4,7,0,  cyan,0,0,7,6,1  //surfaces
dim Surfaces[6,6] \ mcopy surfaces,Surfaces  //create surfaces array
flip on \ Animate = false
while true
   xystring 1,1,"Press Space to animate or Arrows to move"
   ge3dto2da Points,Eye              //calculated screen coordinates
   geVisibles Points,Eye,Surfaces,E    //calculated visible surfaces
   gePlotSurfaces Points,Surfaces           //Plot the surfaces
   geCentroids Points,Surfaces,Centroids    //Centroids

   //gosub Edges
   geplotedges Points,E,2,-2
   for i=0 to 5                      //draw centroids
     if !Surfaces[i,1] then continue //draw centroid only if visible
     circlewh Centroids[i,0]-5,Centroids[i,1]-5,10,10,black,black  //draw triangular centroid of each face
     circlewh Centroids[i,2]-5,Centroids[i,3]-5,10,10,white,white  //draw polygon centroid of each face
   next
   flip \ clearscr
   if Animate then Eye[1] = Eye[1]+.01 \ Eye[2] = Eye[2]+.02  //move the camera
   repeat
      if keydown(kc_UArrow) then Eye[2] = Eye[2]+.02
      if keydown(kc_DArrow) then Eye[2] = Eye[2]-.02
      if keydown(kc_LArrow) then Eye[1] = Eye[1]-.01
      if keydown(kc_RArrow) then Eye[1] = Eye[1]+.01
      if keydown(ascii(" ")) then Animate = !Animate \ waitnokey 150
   until Animate || keydown()
wend

