data Eye;120,pi(.25),pi(.25),1550,400,300     //rho,theta,phi,d,Cx,Cy
data points;0,0,0,0,0, 20,0,0,0,0, 0,20,0,0,0, 0,0,20,0,0

dim Points[maxdim(points,1)/5,5] \ mcopy points,Points        //make appropriate array of vertices
data surfaces;red,0,2,0,3,  blue,0,2,3,1, green,0,1,3,0,  yellow,0,0,2,1  //surfaces
dim Surfaces[4,5] \ mcopy surfaces,Surfaces   //create surfaces array
flip on
while true
   ge3dto2da Points,Eye                    //calculated screen coordinates
   geVisibles Points,Eye,Surfaces,Edges    //calculated visible surfaces
   gePlotSurfaces Points,Surfaces          //Plot and fill visible surfaces
   gePlotEdges Points,Edges,3,-2
   geCentroids Points,Surfaces,Centroids   //Get Centroids data
   for i=0 to 3 //plot visible centroids
     if Surfaces[i,1] then circlewh Centroids[i,0]-5,Centroids[i,1]-5,10,10,white,white
   next  
   flip \ clearscr
   Eye[1] = Eye[1]+.01 \ Eye[2] = Eye[2]+.02  //move the camera
   if keydown(Ascii("X")) then geRotateA Points,.05,1
   if keydown(Ascii("Y")) then geRotateA Points,.05,2
   if keydown(Ascii("Z")) then geRotateA Points,.05,3
   xytext 0,0,"Press X,Y and/or Z to see a nice effect"
wend

