Main:
   GoSub Initialize
   while true
     if s == "" then continue
     readmouse x,y,mb
     if mb == 1 && within(x,700,730) && within(y,50,80)
        n = PromptColor()
        RectangleWH 700,50,30,30,0,n
        waitnokey
     elseif mb == 2 && within(x,2,502) && within(y,2,502)
        n = PixelClr(x,y)        
        RectangleWH 700,50,30,30,0,n
        waitnokey
     elseif mb == 1 && within(x,2,502) && within(y,2,502)
        waitnokey
        if s == "" then continue
        c = PixelClr(x,y)
        CBtoBMP
        OverlayText 10,100,"Please Wait....","Times New Roman",50,fs_Bold
        bmpchangeclr "",c,n,ToNumber(GetEdit("T"),10)/100.0
        fitcb 2,2,500,500
     endif   
   wend
End
//==========================================================
Initialize:
   s = ""
   fnt = "Times New Roman"
   AddEdit "T",700,10,40
   AddSpinner "T",740,10,-1,-1,0,100,1
   AddSpinner "TT",760,13,30,-1,0,100,5,1
   xyText 590,10,"Tolerance %",fnt,15,fs_Bold
   xyText 590,55,"Change To:",fnt,15,fs_Bold
   RectangleWH 700,50,30,30,0
   IntegerEdit "T"
   SetEdit "T",10
   RectangleWH 0,0,504,504,0,0
   BY = 200
   AddButton "&Load",530,BY,100
   AddButton "&Undo",530,BY+25,100
   AddButton "&Reset",530,BY+50,100
   AddButton "&Save",530,BY+90,100
   AddButton "&Instructions",530,BY+115,100
   AddButton "&Test",530,BY+150,100
   Gosub Instructions
   onButton bHandler
   onSpinner spHandler
   onEdit edHandler
   onAbort aHandler
Return
//==========================================================
LoadImage:
   if s == "" then s = promptbmp()
   if s =="" then return
   bmptocb s
   fitcb 2,2,500,500
   n = PixelClr(2,2)
   RectangleWH 700,50,30,30,0,n
   waitnokey
Return
//==========================================================
aHandler:
  x=FileDelete("RobotBASICScreen.Bmp")
Terminate
//==========================================================
edHandler:
  ed = lastEdit()
  x = limit(ToNumber(GetEdit(ed),0),0,100)
  setSpinner ed,x
  setSpinner "TT",x
  setEdit ed,x
  onEdit edHandler
Return
//==========================================================
spHandler:
   sp = lastSpinner()
   SetEdit "T",GetSpinner(sp)
   onSpinner spHandler
Return
//==========================================================
bHandler:
   btn = LastButton()
   if btn == "&Load"
      s = ""
      GoSub LoadImage
   elseif btn == "&Reset" && s != ""
      GOSub LoadImage
   elseif btn == "&Undo" && s != ""
      BMPToCB
      fitcb 2,2,500,500
   elseif btn == "&Save" && s != ""
      f = FileSave(s+".bmp") 
      if f != "" then CBToBMP f
   elseif btn == "&Instructions"
      x = MsgBox(IM)
   elseif btn == "&Test" && s != ""
      rectanglewh 595,395,202,202,black,white
      Transparent on
      FitCB 596,396,200,200
      Transparent off
   endif   
   onButton bHandler
Return
//==========================================================
Instructions:
  data IM;ProgName()
  data IM;"This program allows you to load a Bitmap image and then to"
  data IM;"change the color of pixels in the image.",""
  data IM;"- First load the image by pressing the LOAD button.",""
  data IM;"- Then click on the color square on the right to specify the"
  data IM;"  color you want to change pixels to...you can change this any"
  data IM;"  time you need. Initially it will be loaded with the top left"
  data IM;"  hand pixel's color from the image. You can also fill this box" 
  data IM;"  with the color of any pixel from the image by right-clicking"
  data IM;"  the mouse on the pixel in the image.",""
  data IM;"- Also specify the Tolerance % you need...you can change this any"
  data IM;"  time you need.",""
  data IM;"- Select the color from within the image that you want to change"
  data IM;"  to the color in the box on the right. by clicking on a pixel in"
  data IM;"  the image that has that color.",""
  data IM;"- If you do not like the result press the UNDO button to revert back"
  data IM;"  to the PREVIOUS state....just one level.",""
  data IM;"- The RESET button will revert back to the original image before any"
  data IM;"  changes.",""
  data IM;"- The SAVE button allows you to save the final result to a file.",""
  data IM;"- The TEST button will display the resulting image with the TRANSPARENT"
  data IM;"  setting ON which shows how the image will show when displayed with"
  data IM;"  colors as you have just finished changing them.",""
  //x = MsgBox(IM)
Return
//==========================================================
