   DIR_IMGS = ".\Images\"
//=========================================================
//=========================================================
MainProgram:
  GoSub SetUp
  GoSub Instructions
  While true
    gosub AnimateMan
    gosub CheckButtons
  wend
End
//=========================================================
//=========================================================
SetUp:
  AbortMethod am_Exit
  x_Offset = 35
  flip on
  transparent on
  data Button;"Turn &Flip Off","Turn &Transparent Off"
  data Button;"Turn &Flip On","Turn &Transparent On"
  for i=0 to 1
     Addbutton Button[i],650,50+25*i,130
  next
Return
//=========================================================
AnimateMan:
  for i=1 to 2
    readbmp DIR_IMGS+"DaVinciBackground",x_Offset
    readbmp DIR_IMGS+"davinciman_"+i,x_Offset+60,102
    flip
    delay 200
  next
Return
//=========================================================
CheckButtons:
  GetButton btn
  if btn == Button[0]
     RemoveButton Button[0] \ AddButton Button[2],650,50,130 \ Flip Off
  elseif btn == Button[1]   
     RemoveButton Button[1] \ AddButton Button[3],650,75,130 \ Transparent Off
  elseif btn == Button[2]
     RemoveButton Button[2] \ AddButton Button[0],650,50,130 \ Flip on
  elseif btn == Button[3]   
     RemoveButton Button[3] \ AddButton Button[1],650,75,130 \ Transparent On
  endif   
Return
//=========================================================
Instructions:
   data I_M;"DaVinci_Man.Bas... Instructions..."
   data I_M;"This a simple program to demonstrate the use of animation and bitmap commands."
   data I_M;"Also the use of Back Buffering and Bitmap blending is demonstrated.",""
   data I_M;"The Commands demonstrated are:"
   data I_M;"    Transparent, ReadBmp, Flip",""
   data I_M;"Use the buttons to see the effect of turning Flipping and Transparent on/off.",""
   data I_M;"Other functions and commands you can see in use are:"
   data I_M;"    MsgBox(), AddButtons, RemoveButton, GetButton and AbortMethod",""
   data I_M;"Note:"
   data I_M;"   Apologies to DaVinci fans for the modesty modification to his art. It was"
   data I_M;"   necessary to make it child friendly."
   n = MsgBox(I_M)
Return
//=========================================================
