//This program Demos all the Matrix operations of SBasic
//   MMultiply a,b,c     c=axb   order of a and b matters
//   MDet c,D            D = |c|
//   MInvert c,d,D       d = Inverse(c) and D = |c|
//   MAdd c,d            d = d+c
//   MSub c,d            d = d-c
//   MScale d,ExprN      d = ExprN*d  
//   MDiagonal d,ExprN   d = all zeros excpet along diagonal where it is ExprN
//   MConstant d,ExprN   d = all elements are ExprN
//   MCopy f,g           g = copy of f
//   MTranspose a,b      b = aT
//trace,rank???



L = 3
N = 3
M = 3
dim a[L,N]
dim b[N,M]
GoSub DisplayInstructions
while true
   GoSub Populate   
   GoSub Multiply  //c = axb
   Gosub Deter     //D=determinant(c)
   if D = 0 then continue 
   Gosub Inverse   //e=inverse(c) and D=Determinant(c)
   Gosub Add
   GoSub Subb
   GoSub Scale
   GoSub Diag
   GoSub Const
   GoSub Copy
   GoSub Transpose
wend

//-------------------------------
:Populate
  for i= 0 to L-1
    for j= 0 to N-1
      a[i,j] = random(5)
    next
  next
  for i= 0 to N-1
    for j= 0 to M-1 
      b[i,j] = random(5)
    next
  next
return
//-------------------------------
:Multiply
   frmt = "####0.000"
   print "Multiply c = axb "
   MMultiply a,b,c
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(c[i,j],frmt)
      next
      m=m+"   "
      for j=0 to N-1
         m = m+format(a[i,j],frmt)
      next
      m=m+"   " 
      for j=0 to M-1
        if i< N then m = m+format(b[i,j],frmt)
      next      
      print m
   next
   waitkey mm
   clearscr
return
//-------------------------------
:Deter
   frmt = "####0.000"
   MDet c,D
   print "D= Determinant(c) =  ",D
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(c[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//-------------------------------
:Inverse
   frmt = "####0.000"
   MInvert c,d,D
   print "Inverse(c) = d       Determinant(c) =  ",D
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(c[i,j],frmt)
      next
      m = m+"     " 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   print
   MMultiply d,c,e
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(e[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//-------------------------------
:Add
   frmt = "####0.000"
   print "Addition d = d+c"
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(c[i,j],frmt)
      next
      m = m+"     " 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   MAdd c,d
   print
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//-------------------------------
:Subb
   frmt = "####0.000"
   print "Subtraction d = d-c"
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(c[i,j],frmt)
      next
      m = m+"     " 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   MSub c,d
   print
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//------------------------
:Scale
   frmt = "####0.000"
   print "Scaling d = d*10"
   MCopy d,f
   MScale d,10
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(f[i,j],frmt)
      next
      m=m+"       "
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//------------------------
:Diag
   frmt = "####0.000"
   print "Diagonal Fills d with all zeros except on the diagonal with 2.5"
   MDiagonal d,2.5
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//------------------------
:Const
   frmt = "####0.000"
   print "Fills d with all with 2.5"
   MConstant d,2.5
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(d[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//------------------------
:Copy
   frmt = "####0.000"
   print "Copies f to g"
   MCopy f,g
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(f[i,j],frmt)
      next
      m = m+"     "
      for j=0 to M-1
         m = m+format(g[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//------------------------
:Transpose
   frmt = "####0.000"
   print "g = f transposed"
   MTranspose f,g
   for i=0 to L-1
      m="" 
      for j=0 to M-1
         m = m+format(f[i,j],frmt)
      next
      m = m+"     "
      for j=0 to M-1
         m = m+format(g[i,j],frmt)
      next
      print m
   next
   waitkey mm
   clearscr
return
//------------------------
DisplayInstructions:
  data IM;"Arrays_Math.Bas"
  data IM;"This program demonstrates the power of Array commands"
  data IM;"and functions in RobotBASIC.",""
  data IM;"Various Array math operations are done on randomly"
  data IM;"generarted matrices, such as Add, Multiply, Invert"
  data IM;"determinant etc. See the help file for a complete"
  data IM;"Listing of these commands and functions. Also see"
  data IM;"statistical functions. Like linefit, variance etc."
  n=MsgBox(IM)
Return
//=============================================================
