MainProgram:
  GoSub Initialize
  GoSub MonitorInputs
End
//=======================================================
Initialize:
   xyText 80,10,"Quadratic Equation Solver","",20,fs_Bold|4
   xystring 10,50,"Enter the equation's coefficients..."
   xyText 72,95,"X","",10,fs_BOld
   xyText -1,90,"2","",8,fs_Bold
   xyText -1,95," +","",10,fs_Bold
   xyText 157,95,"X +","",10,fs_BOld
   xyText 225,95," = 0","",10,fs_BOld
   Data Buttons;"&Solve"
   Data Edits;"A","B","C"
   addedit Edits[0],20,90,50,0,"1"," "
   addedit Edits[1],105,90,50,0,"1"," "
   addedit Edits[2],180,90,50,0,"1"," "
   addbutton Buttons[0],80,120
   Dim Coef[5]
   FocusEdit Edits[0]
Return
//=======================================================
MonitorInputs:
   while true
      getbutton btn
      if btn ==Buttons[0] then gosub Solve \ continue
      for i = 0 to 2
        if EditHasFocus(Edits[i]) then Continue
        if !EditChanged(Edits[i]) then continue
        n = ToNumber(GetEdit(Edits[i]))
        if !IsNumber(n) 
           SetEdit Edits[i],"1" 
           FocusEdit ""
           FocusEdit Edits[i]
           n=EditChanged(Edits[i])
        endif   
      next
   wend
Return
//=======================================================
Solve:
   For i= 0 to 2
      Coef[i] = ToNumber(GEtEdit(Edits[i]))
   next 
   b = Coef[1]*Coef[1]-4.0*Coef[0]*Coef[2]
   if Coef[0]==0 && Coef[1] == 0
      Coef[3] = 0 \ Coef[4] = 0
   elseif Coef[0] ==0
      Coef[3] = -1.0*Coef[2]/Coef[1]
      Coef[4] = 0
   elseif b >= 0
      Coef[3]= (Sqrt(b)-Coef[1])/2.0/Coef[0]
      Coef[4]= -(Sqrt(b)+Coef[1])/2.0/Coef[0]
   else
      Coef[4]= Sqrt(abs(b))/2.0/Coef[0]
      Coef[3]= -Coef[1]/2.0/Coef[0]
   endif
   Rectangle 0,140,600,800,white,white
   xyText 10,150,"X1=","",0,fs_Bold
   xyText 10,170,"X2=","",0,fs_Bold
   if Coef[0]==0 && Coef[1] == 0
      xyText 40,160,"Equation is invalid"
   elseif Coef[0] == 0
      xyText 40,150,Coef[3]
      xyText 40,170,"Not Applicable"
   elseif b >= 0
      xyText 40,150,Coef[3]
      xyText 40,170,Coef[4]
   else  
      if Coef[3] == 0
         if Coef[4] != 1
            xyText 40,150," j("+Coef[4]+")"
            xyText 40,170,"-j("+Coef[4]+")"
         else
            xyText 40,150," j"
            xyText 40,170,"-j"
         endif   
      else
         if Coef[4] != 1
            xyText 40,150,""+Coef[3]+"+j("+Coef[4]+")"
            xyText 40,170,""+Coef[3]+"-j("+Coef[4]+")"
         else
            xyText 40,150,""+Coef[3]+"+j"
            xyText 40,170,""+Coef[3]+"-j"
         endif
      endif   
   endif
   FocusEdit Edits[0]
Return
//=======================================================
