Main:
   ScrSetMetrics 650,100,700,250,0
   xyText 10,10,"File To Play:","Times New Roman",10,fs_Bold,blue
   AddEdit "fn",80,8,200
   ReadOnlyEdit "fn"
   data Buttons;"Choose &File","&Play","P&ause","&Stop","&Show Video","&Resume","&Hide Video"
   AddButton Buttons[0],285,6
   for i=0 to 3
      AddButton Buttons[i+1],40+110*i,40,100
   next   
   AddCheckBox "Repea&t",60,70,,,0
   fnt = "Times New Roman"
   xyText 150,70,"State:",fnt,10,fs_Bold
   xyText 290,70,"Video Size:",fnt,10,fs_Bold
   EnableButton Buttons[1],false
   onbutton bHandler
   Paused = false
   xyText 20,110,"Press                 to demo how to Reposition"+\
            " the video window under program control",fnt,13,fs_Bold
   for i= 0 to 3
      drawshape rotshape("lrrqsaw",i),80+i*11,120,4
   next   
   xyText 20,140,"Press - + PgUp PgDn to demo how to "+\
      "Resize the video window under program control",fnt,13,fs_Bold
   FirstTime = true
   while true
     Call MonitorMediaState()
     Call MonitorKeyPresses()
   wend
end
Sub bHandler()
  b = LastButton()
  if b==Buttons[0]
     s = FilePrompt("|All Media Files|*.wav;*.avi;"+\
               "*.wmv;*.mp3;*.mpg;*.mpeg|Others |*.*")
     if s!=""
       SetEdit "fn",s
       EnableButton Buttons[1]
       _FirstTime = true
     endif
  elseif b == Buttons[1]
     MediaPlay 1,GetEdit("fn"),GetCheckBox("Repea&t")
     SetButtonCaption Buttons[2],Buttons[2]
     SetButtonCaption Buttons[4],Buttons[4]
     Call ShowVideoScreen(1)
     _Paused = false
  elseif b == Buttons[2]
     if !_Paused
        SetButtonCaption Buttons[2],Buttons[5]
        MediaPause 1
        _Paused = true
     else
        SetButtonCaption Buttons[2],Buttons[2]
        MediaPause 1,0
        call ShowVideoScreen(0)
        _Paused = false
     endif
  elseif b == Buttons[3]
     MediaStop 1
  elseif b == Buttons[4]
     Call ShowVideoScreen(1)
  endif
  onButton bHandler
Return
Sub ShowVideoScreen(ChangeState)
  if !MediaIsVideo(1) then return
  if !_FirstTime then MediaGetPosition x,y,w,h \ MediaReposition x,y,w,h
  _FirstTime = false
  t = !(GetButtonCaption(Buttons[4]) == Buttons[6])
  if ChangeState
     SetButtonCaption Buttons[4],Buttons[4+2*t]
     MediaShow 1,t
  else
     MediaShow 1
  endif
Return
Sub MonitorMediaState()
  ms = MediaState(1)
  xyString 185,70,ms,"    "
  ms = (ms !=2 && ms != 5)
  for i=2 to 3
     EnableButton Buttons[i], !ms
  next   
  EnableButton Buttons[0], ms
  t = MediaIsVideo(1)
  EnableButton Buttons[4], (!ms && MediaIsVideo(1))
  MediaVideoSize 1,w,h
  xystring 355,70,w,",",h,spaces(10)
Return
Sub MonitorKeyPresses()
  if !keydown() then return
  MediaGetPosition ML,MT,MW,MH
  if KeyDown(kc_LArrow) then MediaReposition ML-10
  if KeyDown(kc_UArrow) then MediaReposition ,MT-10
  if KeyDown(kc_RArrow) then MediaReposition ML+10
  if KeyDown(kc_DArrow) then MediaReposition ,MT+10
  if KeyDown(kc_PUp)    then MediaReposition ,,,MH-10
  if KeyDown(kc_PDn)    then MediaReposition ,,,MH+10
  if KeyDown(189)       then MediaReposition ,,MW-10 // -
  if KeyDown(187)       then MediaReposition ,,MW+10 // +
Return
