MainProgram:
   GoSub Initialization
   while true
      //wait for events
   wend
End
//=================================================================
Initialization:
   addmemo "m",20,20,500,400
   bordermemo "m",0 \ setmemocolor "m",RGB(204,204,255) 
   setmemoscrollbars "m",1 \ setMemoFont "m","",13,fs_Bold
   Rectanglewh 18,18,510,520,black,black
   Rectanglewh 15,15,510,520,black,darkgray
   Line 19,425,519,425,3,gray
   AddMemoLine "m","Enter text here" \ FocusMemo "m"
   SetColor Black,DarkGray
   AddCheckBox "Wrap",22,430,"",1
   AddCheckBox "Vert. Scroll Bar",22,450,"",1
   AddCheckBox "Horz. Scroll Bar",22,470
   SetCheckBoxColor "Wrap",darkgray
   AddEdit "fntS",150,450,50,0,13
   AddSpinner "fntS",203,450 \ setspinner "fntS",13
   xyText 150,435,"Font Size","Ms Sn Serif",8,fs_Bold
   data Fonts;"Courier New","Times New Roman","MS Sans Serif","Arial"
   AddListBox "fntT",225,430,120,mToString(Fonts)
   SetListBox "fntT",3 \ SetListBoxColor "fntT",white
   AddCheckBox "Bold",350,430,"",1
   AddCheckBox "Italic",350,450
   AddCheckBox "Underlined",350,470
   data Buttons;"Clear Memo",440,430,80,       "Memo Color",440,460,80
   data Buttons;"Font Color",230,465,100,      "Read Text File",20,505,100
   data Buttons;"Save Text File",122,505,100,  "Read Encrypted File",258,505,130
   data Buttons;"Save Encrypted File",390,505,130
   for i=0 to Maxdim(Buttons,1)-1 step 4
      AddButton Buttons[i],Buttons[i+1],Buttons[i+2],Buttons[i+3]
   next
   onSpinner sHandler \ onButton bHandler \ onCheckBox cHandler
   onEdit eHandler \ onListBox lHandler
Return
//=================================================================
lHandler:
   ll = LastListBox() \ fntT = GetListBoxText("fntT")
   setmemofont "m",fntT
   onListBox lHandler
Return
//=================================================================
eHandler:
   le = LastEdit() \ fntS= ToNumber(getedit(le))
   if !isNumber(fntS) then fntS = 1
   setspinner le,fntS \ setmemofont "m","",fntS
   OnEdit eHandler
Return
//=================================================================
cHandler:
   lc = LastCheckBox() \ nn = getcheckbox(lc)
   if lc == "Wrap" then wrapmemo "m",nn
   if left(lc,1) == "V" 
       if nn then setmemoscrollbars "m",setbit(memoscrollbars("m"),0)
       if !nn then setmemoscrollbars "m",clrbit(memoscrollbars("m"),0)
   endif    
   if left(lc,1) == "H" 
       if nn then setmemoscrollbars "m",setbit(memoscrollbars("m"),1)
       if !nn then setmemoscrollbars "m",clrbit(memoscrollbars("m"),1)
   endif   
   if Left(lc,1) == "B" || Left(lc,1) == "I" || Left(lc,1) == "U"
       fntSt = getCheckBox("Bold")|(getCheckBox("Italic")*2)
       fntSt = fntSt |(getCheckBox("Underlined")*4) \ setmemofont "m","",-1,fntSt
   endif
   onCheckBox cHandler
Return
//=================================================================
bHandler:
  lb = LastButton()
  if lb == Buttons[0] then clearmemo "m"
  if lb == Buttons[4] then setmemocolor "m",promptcolor(constoclr(getmemocolor("m")))
  if lb == Buttons[8] 
      fc = promptcolor(constoclr(tonumber(extract(getmemofont("m"),crlf(),4))))
      setmemofont "m","",-1,-1,fc
  elseif lb == Buttons[12]
      fln = FilePrompt("*.txt|TextFiles (*.Txt)|*.Txt|Any Files (*.*)|*.*") 
      if fln !="" 
         flh = FileOpen(fln,fo_Read|fo_DenyNone)
         x = FileRead(flh,FileSize(flh)) \ xx = FileClose(flh)
         SetMemoText "m",x
      endif
  elseif lb == Buttons[16]
      fln = FileSave("*.txt|TextFiles (*.Txt)|*.Txt|Any Files (*.*)|*.*") 
      if fln !="" 
         x = FilExt(fln)
         if x=="" then fln = fln+".txt"
         flh = FileCreate(fln)
         x = FileWrite(flh,GetMemoText("m")) \ x = FileClose(flh)
      endif
  elseif lb == Buttons[20]
      fln = FilePrompt("*.Enc|Encrypted Files(*.Enc)|*.Enc|TextFiles (*.Txt)|*.Txt|Any Files (*.*)|*.*")
      if fln !="" 
         flh = FileOpen(fln,fo_Read|fo_DenyNone)
         x = FileRead(flh,FileSize(flh)) \ xx = FileClose(flh)
         xx = StrInput(ProgName(),"Enter a Decryption Password (> 1 character):","")
         if Length(xx)> 1 then SetMemoText "m",Encrypt(x,xx)
      endif
  elseif lb == Buttons[24]
      fln = FileSave("*.Enc|Encrypted Files(*.Enc)|*.Enc|TextFiles (*.Txt)|*.Txt|Any Files (*.*)|*.*")
      if fln !="" 
         x = FilExt(fln)
         if x=="" then fln = fln+".Enc"
         flh = FileCreate(fln)
         xx = StrInput(ProgName(),"Enter an Encryption Password (> 1 character):","")
         if Length(xx) > 1 then x = FileWrite(flh,Encrypt(GetMemoText("m"),xx)) 
         x = FileClose(flh)
      endif
  endif
  onButton bHandler
return
//=================================================================
sHandler:
  ls = LastSpinner() \ fntS = GetSpinner(ls)
  setedit ls,fntS \ setmemofont "m","",fntS
  onSpinner sHandler
return
//=================================================================
