MainProgram:
  gosub Initialization
  while True
    score = 0
    xyString 400,100,"Score = ",score,"   "
    flip
    for tries = 5 to 1
      xyString 375,150,"Tanks left = ",tries
      flip
      NumShots = 0
      hit = false
      while NumShots<2 and not hit
         gosub SelectPower
         ReadMouse a,b,c
         if c=1 and b>500 and a<100 then gosub MoveBall
      wend
      // add up score ********
      if hit and NumShots = 1 then score = score + 3
      if hit and NumShots = 2 then score = score + 1
      xyString 400,100,"Score = ",score,"   "
      flip
      if tries > 1 then gosub MoveTank
    next
    // game over
    xyString 375,150,"Tanks left = 0 "
    xyString 325,200,"Click the mouse for new game"
    flip
    repeat
      ReadMouse a,b,c
    until c=1
    gosub MoveTank
    xyString 325,200,"                            "
    flip
  wend
end


Initialization:
  xs=120
  ys=480
  dx=1
  dy=1
  size=10
  power = 1
  flip on
  xyString 20,35,"Choose Power with"
  xyString 20,50,"      the mouse"
  xyString 10,445,"Click Cannon"
  xyString 10,460,"     to fire"
  LineWidth 5
  gosub InitPower
  gosub DrawCannon
  flip
  gosub InitTank
return

DrawCannon:
  Circle 0,500,100,600,Blue,Blue
  Rectangle 0,550,100,600,Blue,Blue
  Line 50,550,100,500,20,Blue
  Flip
Return

SelectPower:
  ReadMouse a,b,c
  if Within(a,50,150) and Within(b,100,300)
    while c=1
      if within(b,100,300)
        Rectangle 50,100,150,300,Blue,Red
        Rectangle 60,b,140,300,Blue,Blue
        power = 100-(b-100)/2      
        xystring 90,310, power,"  "
        flip
      endif
      ReadMouse a,b,c
    wend
  endif
Return

Fire:
  for t = 17 to 3 step -2
     circle xs-t,ys-t,xs+t,ys+t,red,red
     flip
     delay 5
     circle xs-t,ys-t,xs+t,ys+t,white,white
  next
  flip
return

InitPower:
  Rectangle 50,70,150,330,BLue
  Rectangle 50,100,150,300,Blue,Red
  xyString 80,80,"POWER"
Return

MoveBall:
   //assumes the following
   // size is the size of the ball
   // xs,ys is the starting point
   // dx and dy are the increments
   // MB and S are temporary variables
   // incX and incY are temporary variables
   // x and y are temporary variables
   // lower gravity allows ball to reach right
   // side of screen
   gravity = .08
   fall = 0
   x = xs
   y = ys
   S=size/2
   PlayWav "FireCannon"
   gosub Fire
   while x<800 and y<600
      circle x-S,y-S,x+S,y+S,Black,Black
      flip
      delay 10
      circle x-S,y-S,x+S,y+S,White,White
      incX=dx*power/20.0
      incY=dy*power/20.0
      if incX<1 then incX=1
      if incY<1 then incY=1
      x=x+incX
      y=y-incY+fall
      fall = fall + gravity
   wend
   Flip
   // the following line was modified slightly from
   // the book because the ball could occasionally
   // barely scratch the tank without it blowing up
   if within(x,Tx-5,Tx+60)
      hit = true 
      gosub Explosion
   endif
   NumShots = NumShots+1
Return

InitTank:
  tank = "quwrrwqsrrsrrsdallllllll"
  Tx = 200+Random(550)
  DrawShape tank,Tx,599,5
  gosub MoveTank
return

MoveTank:
  // Tx is the current tank location
  // move it a random distance but never less
  // than 200 nor more than 750
  // now choose a new location
  tx = 200+Random(550)
  for t = Tx to tx
     DrawShape tank,t,599,5
     flip
     DrawShape tank,t,599,5,-1
  next
  Tx = tx
  DrawShape tank,Tx,599,5
  flip
return 

Explosion:
  PlayWav "Explode"
  for t = 5 to 60 step 2
    circle x-t,590-t,x+t,590+t,red,random(16)
    flip
    delay 20
  next
  for t = 60 to 3 step -2
    circle x-t,590-t,x+t,590+t,white,gray 
    flip
  next
return
