//--Figure 6.1
DebugOn
MainProgram:
   gosub DrawObjects  // let the user draw objects on the screen
   gosub RoamAround
End
//=============================================================
RoamAround:
  while true
     // forward until an object is found
     while rFeel( )=0
        rForward 1
Debug "An object was detected   ", rFeel()
     wend
     // try to intelligently turn away from the object
     if rFeel()&3 then Ta = -45 // object on right,turn left
     if rFeel()&24 then Ta = 45 // object on left,turn right
     if rFeel()=4 then Ta = 160 // object infront,turn around
     // turn Ta degrees plus or minus 20 degrees
     rTurn Ta+random(40)*sign(Ta)
  wend
Return
//=============================================================
DrawObjects:  // beginning of subroutine to draw objects
  rLocate 400,300 // show robot so they know where to draw
  print "Press the mouse key and hold it while you draw."
  print "Release when you have completed drawing an object."
  print "Repeat until you have drawn all the objects you want."
  Print "Right click anywhere on the screen when finished"
  Print "The robot will roam randomly while avoiding objects."
  SetColor GREEN
  LineWidth 3
  FirstTime = true
  while true
     // wait till the user presses a mouse button
     repeat
        ReadMouse x,y,m
     until m=1 or m=2
     if FirstTime
        ClearScr  // clear the screen (remove the text)
        rLocate 400,300  // put the robot back on the screen
        FirstTime = false  // only clear screen the first time
     endif
     if m = 2 then return
     gotoxy x,y  // set starting point for drawing
     while m  // as long as the mouse button is pressed 
        ReadMouse x,y,m  // read a new position
        LineTo x,y       // and draw a line to it
     wend
  wend
Return // end of subroutine
//=============================================================
