//--Figure 7.5
MainProgram:
  Gosub DrawLine
  GoSub InitializeRobot
  rForward 10   // move the robot over to the line
  GoSub FollowLine
End
//=============================================================
InitializeRobot:
  //-- place the robot at the beginning of the line 
  //-- and face it left 90 degrees
  rLocate  200, 71, -90  
  rInvisible Green   //-- Green is a line not an object
Return
//=============================================================
DrawLine:
  linewidth 4
  setcolor Green
  gotoxy 170,71
  lineto 160,72
  lineto 145,80
  lineto 140,90
  lineto 130,100
  lineto 125,110
  lineto 120,140
  lineto 130,200
  lineto 140,250
  lineto 130,270
  lineto 145,300
  lineto 200,350
  lineto 300,325
  lineto 450,375
  lineto 450,450
  lineto 600,450
  lineto 600,400
  lineto 650,200
  lineto 500,350
return
//=============================================================
FollowLine:
  c=0
  while c<50    //exit loop if line is not seen for 50 tries
    if rSense() & 1 then rTurn 1
    if rSense() & 4 then rTurn -1
    rForward 1
    if rSense()    // if any sensor sees the line
       c = 0       // start the counter over
    else
       c = c + 1   // increment counter if no line is seen
    endif
  wend
Return
//=============================================================
