//--Figure 7.9
MainProgram:
  Gosub DrawLine
  GoSub InitializeRobot
  GoSub RoamAround
  GoSub FollowLine
End
//=============================================================
InitializeRobot:
  repeat
     readmouse X,Y,b
  Until b = 1
  rLocate  X,Y //locate the robot where the user clicked the mouse
  While b = 1
     readmouse X,Y,b
     rTurn 1 //turn the robot while the mouse is being clicked
     delay 50
  wend
  rInvisible Green   //-- Green is a line not an object
Return
//=============================================================
RoamAround:
 while True 
   // move forward until an object is found
   while (rFeel( )=0) and (rBumper( )=0) and !rSense()
      rForward 1
   wend
   if rSense() then Break
   // turn 180 degrees plus or minus 30 degrees
   rTurn 150 + random (60)
 wend
Return
//=============================================================
DrawLine:
  linewidth 4
  setcolor Green
  Data Coord;-257, 158,  492, 166,  591, 249,  616, 401
  Data Coord; 565, 506,  345, 515,  257, 364,  118, 413
  Data Coord;  62, 243,  185, 217,  256, 157
  MPolygon Coord
return
//=============================================================
FollowLine:
  while true
    rForward 1
    if rSense() = 3
      rForward 20   //move the centre over the corner
      while rSense() = 0  
        rTurn 1    //turn back to the line
      wend
    endif
    if rSense() = 6
      rForward 20   //move the centre over the corner
      while rSense() = 0
        rTurn -1   //turn back to the line
      wend
    endif
    //-- reposition over the line
    while rSense() & 1
      rTurn 1
    wend
    while rSense() & 4
      rturn -1
    wend
  wend
Return
//=============================================================
