//Figure 11.1
MainProgram:
  GoSub DrawOffice
  GoSub InitRobot
  gosub MoveRobot
End
//=============================================================
InitRobot:
  RR = 11
  LnClr = Cyan
  rlocate 400,300,random(360),RR
  rInvisible LnClr
  rpen down
  linewidth (RR-3)*2
Return
//=============================================================
DrawOffice:   
  LineWidth 15 
  Data Walls;-165,140,165,0,-357,245,0,245,-590,513,590,600
  Data Walls;-165,140,255,140,-360,140,517,140
  Data Walls;-644,140,797,140,-517,140,517,0,-474,245,699,245
  Data Walls;-474,246,474,419,797,419,-357,247,357,470,113,470
  MPolygon Walls

  Cabinet_H = "rrrddddllluuuu"
  Cabinet_V = "dddlllluuurrrr"
  Desk_H    = "rrrrrrrrrrdddddlllluuuulllllddddluuuuu"
  Desk_V    = "ddddddddddllllluuuurrrruuuuullllurrrrr"
  linewidth 1
  //Desks & Cabinets Locations
  Data Furniture; "CH",478,0,"CH",597,559,"CH",769,370
  Data Furniture; "CH",0,252,"CH",551,559,"CH",0,0
  Data Furniture; "CV",564,0,"CV",40,569,"CV",214,569
  Data Furniture; "CV",548,569,"CV",169,569,"CV",156,0
  Data Furniture; "DV",348,300,"DV",800,496,"DV",800,0
  Data Furniture; "DH",481,252,"DH",259,0
  //Draw them
  For I = 0 to MaxDim(Furniture,1)-1 step 3
     if Furniture[I] = "CH" then ss = Cabinet_H
     if Furniture[I] = "DH" then ss = Desk_H
     if Furniture[I] = "CV" then ss = Cabinet_V
     if Furniture[I] = "DV" then ss = Desk_V
     DrawShape ss,Furniture[I+1],Furniture[I+2],10
  next
  //Shade them
  Data FF_Furniture;10,-17,10,-271,488,-21,573,-579,782,-395        
  Data FF_Furniture; 612,-585,140,-19,544,-24,22,-584,151
  Data FF_Furniture; -586,198,-580,530,-591,337,-34,776,-80
  Data FF_Furniture; 323,-388, 565,-274, 772,-580
  MPolygon FF_Furniture,gray

  //Tables
  Circle 59,69,109,119,darkgray,darkgray
  Circle 118,329,168,379,darkgray,darkgray
  //Chairs
  Data Chairs;275,67,699,16,500,319,245,316,693,512,75,279
  for I = 0 to MaxDim(Chairs,1)-1 step 2
     X = Chairs[I]
     Y = Chairs[I+1]
     Sp = 35  //leg spacing
     LD = 4   //leg diameter
     Cl = Brown  //color for legs
     Circle X,Y,X+LD,Y+LD,Cl,Cl
     Circle X+Sp,Y,X+Sp+LD,Y+LD,Cl,Cl
     Circle X,Y+Sp,X+LD,Y+Sp+LD,Cl,Cl
     Circle X+Sp,Y+Sp,X+Sp+LD,Y+Sp+LD,Cl,Cl
  next
Return
//=============================================================
MoveRobot:
   //left blank for now
Return
//=============================================================
