//---Figure 12.1 to 7
MainProgram:
  While true
    GoSub SetEnvironment
    GoSub FindBeacon
  Wend
End
//=============================================================
SetEnvironment:
  ClearScr
  // Draw three circles and three squares
  For i=1 to 3
    SetColor Black
    LineWidth 4
    x = random(450) + 100
    y = random(300)+100
    size = random(50)+50
    Circle x,y,x+size,y+size
    x = Random(450)+100
    y = Random(300)+100
    size = random(100)+50
    Rectangle x,y,x+size,y+size
  Next
  // place robot
  rLocate 25,Random(350)+100
  rInvisible Red
  // place beacon
  bx =750
  by = Random(350)+100
  Circle bx-10,by-10,bx+10,by+10,red,red
Return
//=============================================================
FindBeacon:
  Repeat
    GoSub FaceBeacon
    GoSub ForwardTillBlocked
    TurnDir = 1
    GoSub GoAround
  Until BeaconFound
Return
//=============================================================
FaceBeacon:
  While not rBeacon(Red)
    rTurn 1
  Wend
Return
//=============================================================
ForwardTillBlocked:
  While not (rFeel() & 14) AND not (rBumper() & 14)
    rForward 1
    GoSub CheckFound
    If BeaconFound Then break
  Wend
Return
//=============================================================
CheckFound:
  BeaconFound =  Within(rBeacon(Red),1,20) 
Return
//=============================================================
GoAround: 
  If BeaconFound Then return
  rTurn -random(150)
  If TurnDir > 0 
     FN  = 6
  Else
     FN  = 12
  Endif
  For i=1 to 20 + random(250)
    While (rFeel() & FN) or (rBumper() &4)
      rTurn -TurnDir
    Wend
    rForward 1  // forward always to prevent stall
    While not rFeel() // turn back quickly to find wall again
      rTurn 5*TurnDir
      rForward 1
    Wend
  Next
Return
//=============================================================
