//---Figure 12.10
MainProgram:
  While true
    GoSub SetEnvironment
    GoSub FindBeacon
  Wend
End
//=============================================================
SetEnvironment:
  ClearScr
  // Draw three circles and three squares
  For i=1 to 3
    SetColor Black
    LineWidth 4
    x = random(450) + 100
    y = random(300)+100
    size = random(50)+50
    Circle x,y,x+size,y+size
    x = Random(450)+100
    y = Random(300)+100
    size = random(100)+50
    Rectangle x,y,x+size,y+size
  Next
  // place robot
  rLocate 25,Random(350)+100
  rInvisible Red
  // place beacon
  bx =750
  by = Random(350)+100
  Circle bx-10,by-10,bx+10,by+10,red,red
  Circle bx-7,by-7,bx+7,by+7,blue,blue
Return
//=============================================================
FindBeacon:
  cnt=0
  Repeat
    cnt=cnt+1
    GoSub FaceBeacon
    if cnt <20
      GoSub ForwardTillBlocked
      If (cnt=1) and (rFeel()&8) Then cnt=10
      TurnDir = 1
      GoSub GoAround
    Else
      GoSub UnStick
      cnt=0
    Endif
  Until BeaconFound
Return
//=============================================================
UnStick:
  If Random(100)<50 Then rTurn 180
  For i=0 to 100+random(200)
    While not(rbumper()&14) 
      rForward 1
    Wend 
    rTurn Random(8)-3
  Next
Return
//=============================================================
FaceBeacon:
   dx = bx-rGpsX()
   dy = by-rGpsY()
   If dx=0 AND dy = 0 Then Return
   Theta = PolarA(dx,dy)*180/pi(1)+90-rCompass()
   If Theta > 180 Then Theta = Theta-360
   If Theta < -180 Then Theta = Theta+360
   rTurn Theta
Return
//=============================================================
ForwardTillBlocked:
  While not (rFeel() & 14) AND not (rBumper() & 14)
    rForward 1
    GoSub CheckFound
    If BeaconFound Then break
  Wend
return
//=============================================================
CheckFound:
  rGPS x,y
  // remember beacon is at bx,by
  If PolarR(x-bx,y-by)<50
    BeaconFound = true
  Else
    BeaconFound = false
  Endif
Return
//=============================================================
GoAround: 
  If BeaconFound Then return
  rTurn -random(150)
  If TurnDir > 0 
     FN  = 6
  Else
     FN  = 12
  Endif
  For i=1 to 20 + random(250)
    While (rFeel() & FN) or (rBumper() &4)
      If rLook()=Blue Then Return
      rTurn -TurnDir
    Wend
    rForward 1  // forward always to prevent stall
    While not rFeel() // turn back quickly to find wall again
      rTurn 5*TurnDir
      rForward 1
      If rLook()=Blue Then Return
    Wend
  Next
Return
//=============================================================
