
//----------RB2Prop_IO_Text.Bas------------------------
//  Use the SPIN program RB2Prop_IO_Text.Spin.

CommPort = 4  //change this to reflect your setup
setcommport CommPort,br115200,8,pNone,sbOne,fcNone
ClearSerBuffer
xystring 10,5,"Automatically Resetting The Propeller Program now...."
setserdtr \ setserdtr 0 \ setserdtr
while true
   repeat  //wait for the "Rdy"
     checkserbuffer n
   until n == 3
   SerIn s \ if s == "Rdy" then break
wend //repeat until the "Rdy" string is received
//add edit boxes and buttons and instructions
addedit "v1",50,50,100,0,70 
addedit "v2",170,50,100,0,48
addedit "re",310,50,100,0,"0"  \ readonlyedit "re"
addbutton "Calc",80,100,100
xystring 10,5,"OK the Propeller is ready...."+spaces(10)
xystring 10,25,"Enter numbers in the edit boxes then press the 'Calc' button"
xytext 155,45,"+","",15
xytext 290,45,"=","",15
while true  //repeat for ever
  repeat  //wait for the calc button to be pressed
  until LastButton() =="Calc"
  //get the numbers from the edit boxes
  v1 = tonumber(getedit("v1"),0) \ v2 = tonumber(getedit("v2"),0)
  //send the two numbers as text one after the other 
  //the delay is to give the Propeller time to be ready
  //the char(13) is to indicate the end of the text for the propeller
  serout v1,char(13) \  serout v2,char(13)
  repeat //wait until there is atleast one byte in the buffer
    checkserbuffer n
  until n>=1
  delay 10 //give the the Propeller time to finish
            //sending the text number there is no way to know 
            //how many characters but should not take longer
            //than 10 ms to send all of them at the 115200 baud
            //may need longer if slower baud is used
  serin s   //read the buffer
  //assign the number (text) to the result edit box
  setedit "re",tonumber(s)
wend
