if usbm_DllSpecs() != ""
   if usbm_FindDevices() 
      //---there is a device and we will use device 0
      n=usbm_DirectionA(0,0xFF,0xFF) //set port A0 to A7 as outputs
      n=usbm_DirectionB(0,0,0xFF)    //set port B0 to B7 as inputs
      n=usbm_WriteB(0,0xFF)          //with internal pull-up resistors
      xyText 10,10,"Port B => A Status:","",20,fs_Bold|fs_Underlined
      for i=0 to 7
         addcheckbox ""+i,30+20*(7-i),60," "
      next
      while true
          n = usbm_ReadB(0)
          for i=0 to 7
             if GetBit(n,i)
                m = usbm_SetBit(0,i)
                SetCheckBox ""+i
             else
                m = usbm_ResetBit(0,i)
                SetCheckBox ""+i,false
             endif   
          next
          delay 100
      wend
   else
      print "There are no Devices"
   endif   
else
   print "The USBmicro DLL is not installed"   
endif

