MainProgram:
 DeviceNum = 0    //use device 0
 Thermo_Pin = 4   //use pin A4 for input from the DS1820 
 if usbm_DllSpecs() != ""
   if usbm_FindDevices() 
     //---there is a device and we will use device DeviceNum
     xyText 10,10,"Temperature =","",15,fs_Bold
     while true
       GoSub Read_ThermoData
       xyText 160,10,Format(Tc,"##0.00C = ")+Format(Tf,"0.00F")+spaces(10),"",15
     wend   
   else
     print "There are no Devices"
   endif   
 else
   print "The USBmicro DLL is not installed"   
 endif
end
//================================================
01 Read_ThermoData:
02   if !usbm_DeviceValid(DeviceNum) then Tc = -40 \ Tf = -40 \return
03   n = usbm_reset1wire(DeviceNum,Thermo_Pin)
04   n =usbm_write1wire(DeviceNum,0xCC) \ n =usbm_write1wire(DeviceNum,0x44)
05   n =usbm_reset1wire(DeviceNum,Thermo_Pin)
06   n =usbm_write1wire(DeviceNum,0xCC) \ n =usbm_write1wire(DeviceNum,0xBE)
07   n =usbm_read1wire(DeviceNum) \ m = usbm_read1wire(DeviceNum)
08   x = 0 \ if(m & 0x80) then x = 0xFFFFF000
09   Tc = (x |(((m & 0x0F)<< 8)+n))*0.0625
10   Tf = Tc*1.8+32
11 Return
//=========================================================
