MainProgram:
  GoSub Initialization
  if AllOk
     while true
       n=usbm_ReadA(DeviceNum)
       xytext 10,10,bin((n >>((Channel-1)*4))&0x0F,4),"",20,fs_Bold
       waitkey k
       GoSub Stepper   
     wend
  endif
End
//==============================================================
Initialization:
   DeviceNum = 0 \ AllOk = false
   if usbm_DllSpecs() == "" then print "The USBm.Dll is not installed" \return
   if !usbm_FindDevices() then print "There are no U4x1 devices" \return
   Channel     = 1
   Enable      = 0
   Direction   = 0  //0=right  1=left
   movetype = 0 //---0 = half, 1 = full, 2 = wave
   if movetype = 0 then Type = 0 \ Initial = 3
   if movetype = 1 then Type = 1 \ Initial = 3
   if movetype = 2 then Type = 1 \ Initial = 1
   Rate        = 255
   Steps       = 1
   S = toByte(Channel)+toByte(Enable)+toByte(Direction)
   S = S+toByte(Type)+toByte(Initial)+toByte(Rate)+toByte(0)
   if usbm_DeviceValid(DeviceNum)
      n = usbm_DirectionA(DeviceNum,255,255)  //SetPort A to output
      n = usbm_Stepper(DeviceNum,S)           //Initialize motor
      S = BuffWriteB(S,1,1)                   //
      n = usbm_Stepper(DeviceNum,S)           //turn it on but no steps
      AllOk = true
   endif   
Return
//==============================================================
Stepper:
  S = BuffWriteB(S,6,Steps)
  n = usbm_Stepper(DeviceNum,S)  //do the steps
Return
//==============================================================
